<?php

/*

 Website Baker Project <http://www.websitebaker.org/>
 Copyright (C) 2004-2005, Ryan Djurovich

 Website Baker is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 Website Baker is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Website Baker; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

// Must include code to stop this file being access directly
if(defined('WB_PATH') == false) { exit("Cannot access this file directly"); }

// Define config vars
define('THUMB_PREPEND', '<img src="');
define('THUMB_APPEND', '" border="0" class="thumbnail" />');
define('NEW_ROW', '</tr><tr>');

// Check if there is a start point defined
if(isset($_GET['p']) AND is_numeric($_GET['p']) AND $_GET['p'] >= 0) {
	$position = $_GET['p'];
} else {
	$position = 0;
}

// Get user's username, display name, email, and id - needed for insertion into image info
$users = array();
$query_users = $database->query("SELECT user_id,username,display_name,email FROM ".TABLE_PREFIX."users");
if($query_users->numRows() > 0) {
	while($user = $query_users->fetchRow()) {
		// Insert user info into users array
		$user_id = $user['user_id'];
		$users[$user_id]['username'] = $user['username'];
		$users[$user_id]['display_name'] = $user['display_name'];
		$users[$user_id]['email'] = $user['email'];
	}
}

// Check if we should show the main page or a image itself
if(!defined('IMAGE_ID') OR !is_numeric(IMAGE_ID)) {
	
	// Get settings
	$query_settings = $database->query("SELECT * FROM ".TABLE_PREFIX."mod_gallery_settings WHERE section_id = '$section_id'");
	if($query_settings->numRows() > 0) {
		$fetch_settings = $query_settings->fetchRow();
		$setting_header = stripslashes($fetch_settings['header']);
		$setting_image_loop = stripslashes($fetch_settings['image_loop']);
		$setting_footer = stripslashes($fetch_settings['footer']);
		$setting_images_per_page = $fetch_settings['images_per_page'];
		$setting_num_cols = $fetch_settings['num_cols'];
		$setting_resize = stripslashes($fetch_settings['resize']);
	} else {
		$setting_header = '';
		$setting_image_loop = '';
		$setting_footer = '';
		$setting_images_per_page = '';
		$setting_num_cols = '';
		$setting_resize = '';
	}
	
	// Get total number of images
	$query_total_num = $database->query("SELECT image_id FROM ".TABLE_PREFIX."mod_gallery_images WHERE section_id = '$section_id' AND active = '1' AND title != ''");
	$total_num = $query_total_num->numRows();

	// Work-out if we need to add limit code to sql
	if($setting_images_per_page != 0) {
		$limit_sql = " LIMIT $position,$setting_images_per_page";
	} else {
		$limit_sql = "";
	}
	
	// Query images (for this page)
	$query_images = $database->query("SELECT image_id,title,link,description,modified_by,modified_when,extension FROM ".TABLE_PREFIX."mod_gallery_images WHERE section_id = '$section_id' AND active = '1' AND title != '' ORDER BY position ASC".$limit_sql);
	$num_images = $query_images->numRows();
	
	// Create previous and next links
	if($setting_images_per_page != 0) {
		if($position > 0) {
			if(isset($_GET['g']) AND is_numeric($_GET['g'])) {
				$pl_prepend = '<a href="?p='.($position-$setting_images_per_page).'&g='.$_GET['g'].'"><< ';
			} else {
				$pl_prepend = '<a href="?p='.($position-$setting_images_per_page).'"><< ';
			}
			$pl_append = '</a>';
			$previous_link = $pl_prepend.$TEXT['PREVIOUS'].$pl_append;
			$previous_page_link = $pl_prepend.$TEXT['PREVIOUS_PAGE'].$pl_append;
		} else {
			$previous_link = '';
			$previous_page_link = '';
		}
		if($position+$setting_images_per_page >= $total_num) {
			$next_link = '';
			$next_page_link = '';
		} else {
			if(isset($_GET['g']) AND is_numeric($_GET['g'])) {
				$nl_prepend = '<a href="?p='.($position+$setting_images_per_page).'&g='.$_GET['g'].'"> ';
			} else {
				$nl_prepend = '<a href="?p='.($position+$setting_images_per_page).'"> ';
			}
			$nl_append = ' >></a>';
			$next_link = $nl_prepend.$TEXT['NEXT'].$nl_append;
			$next_page_link = $nl_prepend.$TEXT['NEXT_PAGE'].$nl_append;
		}
		if($position+$setting_images_per_page > $total_num) {
			$num_of = $position+$num_images;
		} else {
			$num_of = $position+$setting_images_per_page;
		}
		$out_of = ($position+1).'-'.$num_of.' '.strtolower($TEXT['OUT_OF']).' '.$total_num;
		$of = ($position+1).'-'.$num_of.' '.strtolower($TEXT['OF']).' '.$total_num;
		$display_previous_next_links = '';
	} else {
		$display_previous_next_links = 'none';
	}
		
	// Print header
	if($display_previous_next_links == 'none') {
		echo  str_replace(array('[NEXT_PAGE_LINK]','[NEXT_LINK]','[PREVIOUS_PAGE_LINK]','[PREVIOUS_LINK]','[OUT_OF]','[OF]','[DISPLAY_PREVIOUS_NEXT_LINKS]'), array('','','','','','', $display_previous_next_links), $setting_header);
	} else {
		echo str_replace(array('[NEXT_PAGE_LINK]','[NEXT_LINK]','[PREVIOUS_PAGE_LINK]','[PREVIOUS_LINK]','[OUT_OF]','[OF]','[DISPLAY_PREVIOUS_NEXT_LINKS]'), array($next_page_link, $next_link, $previous_page_link, $previous_link, $out_of, $of, $display_previous_next_links), $setting_header);
	}
	
	// Loop through and show images
	if($num_images > 0) {
		$counter = 0;
		while($image = $query_images->fetchRow()) {
			$uid = $image['modified_by']; // User who last modified the image
			// Workout date and time of last modified image
			$image_date = gmdate(DATE_FORMAT, $image['modified_when']+TIMEZONE);
			$image_time = gmdate(TIME_FORMAT, $image['modified_when']+TIMEZONE);
			// Work-out the image link
			$image_link = WB_URL.$image['link'].'.php';
			if(isset($_GET['p']) AND $position > 0) {
				$image_link .= '?p='.$position;
			}
			if(isset($_GET['g']) AND is_numeric($_GET['g'])) {
				if(isset($_GET['p']) AND $position > 0) { $image_link .= '&'; } else { $image_link .= '?'; }
				$image_link .= 'g='.$_GET['g'];
			}
			// image file extension
			$ext = $image['extension'];
			// Check if we should show thumb or image or nothing at all
			if($setting_resize > 0) {
				if(file_exists(WB_PATH.MEDIA_DIRECTORY.'/.gallery/thumb'.$image['image_id'].'.jpg'))
				{
					$thumb = THUMB_PREPEND.WB_URL.MEDIA_DIRECTORY.'/.gallery/thumb'.$image['image_id'].'.jpg'.THUMB_APPEND;
				} else {
					$thumb = '';
				}
			} else {
				if(file_exists(WB_PATH.MEDIA_DIRECTORY.'/.gallery/image'.$image['image_id'].'.'.$ext))
				{
					$thumb = THUMB_PREPEND.WB_URL.MEDIA_DIRECTORY.'/.gallery/image'.$image['image_id'].'.'.$ext.THUMB_APPEND;
				} else {
					$thumb = '';
				}
			}
			// Replace vars with values
			$vars = array('[PAGE_TITLE]', '[THUMB]', '[TITLE]', '[DESCRIPTION]', '[LINK]', '[DATE]', '[TIME]', '[USER_ID]', '[USERNAME]', '[DISPLAY_NAME]', '[EMAIL]', '[TEXT_READ_MORE]');
			if(isset($users[$uid]['username']) AND $users[$uid]['username'] != '') {
				$values = array(PAGE_TITLE, $thumb, stripslashes($image['title']), stripslashes($image['description']), $image_link, $image_date, $image_time, $uid, $users[$uid]['username'], $users[$uid]['display_name'], $users[$uid]['email'], $TEXT['READ_MORE']);
			} else {
				$values = array(PAGE_TITLE, $thumb, stripslashes($image['title']), stripslashes($image['description']), $image_link, $image_date, $image_time, '', '', '', '', $TEXT['READ_MORE']);
			}
			echo str_replace($vars, $values, $setting_image_loop);
			// Increment counter
			$counter = $counter+1;
			// Check if we should end this row
			if($counter == $setting_num_cols) {
				$counter = 0;
				echo NEW_ROW;
			}
		}
	}
	
	// Print footer
	if($display_previous_next_links == 'none') {
		echo  str_replace(array('[NEXT_PAGE_LINK]','[NEXT_LINK]','[PREVIOUS_PAGE_LINK]','[PREVIOUS_LINK]','[OUT_OF]','[OF]','[DISPLAY_PREVIOUS_NEXT_LINKS]'), array('','','','','','', $display_previous_next_links), $setting_footer);
	} else {
		echo str_replace(array('[NEXT_PAGE_LINK]','[NEXT_LINK]','[PREVIOUS_PAGE_LINK]','[PREVIOUS_LINK]','[OUT_OF]','[OF]','[DISPLAY_PREVIOUS_NEXT_LINKS]'), array($next_page_link, $next_link, $previous_page_link, $previous_link, $out_of, $of, $display_previous_next_links), $setting_footer);
	}
	
} elseif(defined('IMAGE_ID') AND is_numeric(IMAGE_ID)) {
	
	// Get settings
	$query_settings = $database->query("SELECT * FROM ".TABLE_PREFIX."mod_gallery_settings WHERE section_id = '$section_id'");
	if($query_settings->numRows() > 0) {
		$fetch_settings = $query_settings->fetchRow();
		$setting_image_header = stripslashes($fetch_settings['image_header']);
		$setting_image_footer = stripslashes($fetch_settings['image_footer']);
	} else {
		$setting_image_header = '';
		$setting_image_footer = '';
	}
	
	// Get page info
	$query_page = $database->query("SELECT link FROM ".TABLE_PREFIX."pages WHERE page_id = '".PAGE_ID."'");
	if($query_page->numRows() > 0) {
		$page = $query_page->fetchRow();
		$page_link = page_link($page['link']);
		if(isset($_GET['p']) AND $position > 0) {
			$page_link .= '?p='.$_GET['p'];
		}
	} else {
		exit('Page not found');
	}
	
	// Get total number of images
	$query_total_num = $database->query("SELECT image_id FROM ".TABLE_PREFIX."mod_gallery_images WHERE section_id = '$section_id' AND active = '1' AND title != ''");
	$total_num = $query_total_num->numRows();
	
	// Get image info
	$query_image = $database->query("SELECT * FROM ".TABLE_PREFIX."mod_gallery_images WHERE image_id = '".IMAGE_ID."' AND active = '1'");
	if($query_image->numRows() > 0) {
	$image = $query_image->fetchRow();	
	$position = $image['position'];
	$ext = $image['extension'];
	
		// Create previous and next links
		$query_surrounding = $database->query("SELECT image_id FROM ".TABLE_PREFIX."mod_gallery_images WHERE position != '$position' AND section_id = '$section_id' LIMIT 1");
		if($query_surrounding->numRows() > 0) {
			// Get previous
			if($position > 1) {
				$query_previous = $database->query("SELECT link,position FROM ".TABLE_PREFIX."mod_gallery_images WHERE position < '$position' AND section_id = '$section_id' ORDER BY position DESC LIMIT 1");
				if($query_previous->numRows() > 0) {
					$previous = $query_previous->fetchRow();
					$previous_link = '<a href="'.WB_URL.$previous['link'].'.php"><< '.$TEXT['PREVIOUS'].'</a>';
				}
			} else {
				$previous_link = '';
			}
			// Get next
			if($position >= $total_num) {
				$next_link = '';
			} else {
				$query_next = $database->query("SELECT link,position FROM ".TABLE_PREFIX."mod_gallery_images WHERE position > '$position' AND section_id = '$section_id' ORDER BY position ASC LIMIT 1 ");
				if($query_next->numRows() > 0) {
					$next = $query_next->fetchRow();
					$next_link = '<a href="'.WB_URL.$next['link'].'.php"> '.$TEXT['NEXT'].' >></a>';
				}
			}
		} else {
			$next_link = '';
			$previous_link = '';
		}
		$out_of = $position.' '.strtolower($TEXT['OUT_OF']).' '.$total_num;
		$of = $position.' '.strtolower($TEXT['OF']).' '.$total_num;
		
		// Show image
		$uid = $image['modified_by']; // User who last modified the image
		// Workout date and time of last modified image
		$image_date = gmdate(DATE_FORMAT, $image['modified_when']+TIMEZONE);
		$image_time = gmdate(TIME_FORMAT, $image['modified_when']+TIMEZONE);
		// Set vars and value
		$vars = array('[PAGE_TITLE]', '[TITLE]', '[DESCRIPTION]', '[BACK]', '[DATE]', '[TIME]', '[USER_ID]', '[USERNAME]', '[DISPLAY_NAME]', '[EMAIL]', '[PREVIOUS]', '[NEXT]', '[OUT_OF]', '[OF]', '[TEXT_OUT_OF]', '[TEXT_OF]');
		if(isset($users[$uid]['username']) AND $users[$uid]['username'] != '') {
			$values = array(PAGE_TITLE, stripslashes($image['title']), stripslashes($image['description']), $page_link, $image_date, $image_time, $uid, $users[$uid]['username'], $users[$uid]['display_name'], $users[$uid]['email'], $previous_link, $next_link, $out_of, $of,  $TEXT['OUT_OF'], $TEXT['OF']);
		} else {
			$values = array(PAGE_TITLE, stripslashes($image['title']), stripslashes($image['description']), $page_link, $image_date, $image_time, '', '', '', '', $previous_link, $next_link, $out_of, $of, $TEXT['OUT_OF'], $TEXT['OF']);
		}
		
		// Print post header
		echo str_replace($vars, $values, $setting_image_header);
		
		// Show image
		if(file_exists(WB_PATH.MEDIA_DIRECTORY.'/.gallery/image'.$image['image_id'].'.'.$ext)) {
			echo THUMB_PREPEND.WB_URL.MEDIA_DIRECTORY.'/.gallery/image'.$image['image_id'].'.'.$ext.THUMB_APPEND;
		}
		
		// Print post footer
		echo str_replace($vars, $values, $setting_image_footer);
	
	} else {
		header('Location: '.WB_URL.'/pages/');
	}
		
}

?>